-- *************************************************************************
-- Matlib Renderer V0.5 by Sven 'fIRE3D' Dahl / www.brazelized.de
-- Preferences
-- Size for the generated image (can be changed in the rollout)
-- *************************************************************************
ImgWdh = 480
ImgHgt = 360
-- *************************************************************************
-- Size for the gemerated Thumbmail (can be changed in the rollout)
-- *************************************************************************
thumbWdh = 160
thumbHgt = 120
-- *************************************************************************
-- Html output Columns (thumbs per line)
-- *************************************************************************
htmlcolumns = 7
-- *************************************************************************
-- Output Directory - change this if you dont want to select it always new
-- *************************************************************************
outDir =  getDir#image
-- *************************************************************************
-- Scene File for rendering - if you change this to your own
-- i have used 5 Objectnames box - sphere - teapot - torus - plane
-- *************************************************************************
smpfile = "$scripts/mlr/sample.max"
-- **************************************************************************


rollout RenderMatlib "Matlib Render"
(

	group "Material Library + Settings"
		(
		label maxmat "Get Mat file:" pos:[10, 26]
		edittext matLib text:(filenameFromPath (getMatLibFileName())) fieldwidth:140 pos:[90, 24]
		button get_matlib "..." toolTip:"Choose *.mat" pos:[250, 22]
		label mc "Materials found:" align:#left  pos:[10, 50]
		edittext MatlibCount text:((currentMaterialLibrary).count as string)  fieldwidth:20 pos:[90, 48]
		
		)
			
			on get_matlib pressed do
			(
			pick_matlib = (fileOpenMatLib())
			if pick_matlib != "" then matLib.text = filenameFromPath (getMatLibFileName())
			if matLib.text == "" then matLib.text = "Own Scene"
			if pick_matlib != undefined then MatlibCount.text = (currentMaterialLibrary).count as string
	        )

			
	group "Image Settings"
		(
		label info "Setup Image size for Rendering here" pos:[10, 92]
		label output1 "Image W/H:" pos:[10, 112]
		spinner bitmapWidth type:#integer range:[1,1600,ImgWdh] align:#left fieldwidth:35 pos:[78, 112]
		spinner bitmapHeight type:#integer range:[1,1200,ImgHgt] align:#left fieldwidth:35 pos:[130, 112]


		label output2 "Thumb W/H:" pos:[10, 132]
		spinner thumbnailWidth type:#integer range:[1,640,thumbWdh] align:#left fieldwidth:35 pos:[78, 132]
		spinner thumbnailHeight type:#integer range:[1,480,thumbHgt] align:#left fieldwidth:35 pos:[130, 132]
		)

			on bitmapWidth changed val do ImgWdh = bitmapWidth.value
			on bitmapWidth entered do ImgWdh = bitmapWidth.value
			on bitmapHeight changed val do ImgHgt = bitmapHeight.value
			on bitmapHeight entered do ImgHgt = bitmapHeight.value
			on thumbnailWidth changed val do thumbWdh = thumbnailWidth.value
			on thumbnailWidth entered do thumbWdh = thumbnailWidth.value
			on thumbnailHeight changed val do thumbHgt = thumbnailHeight.value
			on thumbnailHeight entered do thumbHgt = thumbnailHeight.value


	group "Export"
		(
		label outputTo "Html Export Dir:" align:#left
		edittext outputPath text:outDir fieldwidth:130 align:#left
		label direct "Get Path:" pos:[170, 196]
		button changeOutputPath "..." tooltip:"Select Path - for permanent change - edit the path in the Script at the Top" pos:[220, 192]
		)

	group "Render"
		(
		button generate "Generate!"
		)
			

			on changeOutputPath pressed do
			(
			tmpPath = getSavePath()
			if tmpPath  == undefined then outDir = getDir#image else outDir = tmpPath  
			if tmpPath == undefined then outputPath.text = getDir#image else outputPath.text = tmpPath  
			)
			
	group "Info"
		(
	 	label info1 "Matlib Render"
		label info2 "Version 0.5 beta / by Sven 'fIRE3D' Dahl"
		label info3 "http://www.brazelized.de"
			)
	
	group ""
		(
		bitmap logo fileName:"logo.jpg"
		)
			
							on generate pressed do
				(
				
					-- Ask for Reset
					actionMan.executeAction 0 "40005"
					
					loadMaxFile smpfile
					renderPresets.LoadCategories (GetDir #renderPresets + "/html_scanline.rps")
					
					renderpresets.Load 0 (GetDir #renderPresets + "\\html_scanline.rps") #{32}
					
					meditMaterials[1] = MatteShadow ()
					meditMaterials[1].shadowBrightness = 0.5
					
					-- Put Material on the Objects
					select $box
					$.material = meditMaterials[1]				
					select $box
					selectMore $teapot
					selectMore $sphere
					selectMore $torus
					selectMore $text
					
					actionMan.executeAction 0 "40068"
							

HtmlOut = createFile (outDir + "\\" + matLib.text + ".html")
 	
Format "%"  "<head>\n" to:HtmlOut
Format "%"  "<title>" to:HtmlOut
Format "%" 	"</title>\n"  to:HtmlOut
Format "%"  "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n"  to:HtmlOut
Format "%"  "</head>\n"  to:HtmlOut
Format "%"  "<body bgcolor=\"#FFFFFF\" text=\"#000000\">\n"  to:HtmlOut
Format "%"	"<p align=\"center\">\n" to:HtmlOut
Format "%"	"</p>\n" to:HtmlOut
Format "%"	"<table border=\"1\" align=\"center\" cellpadding=\"2\" cellspacing=\"2\" bordercolor=\"#000000\" bgcolor=\"#333333\">\n" to:HtmlOut
Format "%"	"<tr>\n" to:HtmlOut

					

					mats = #()
					for m in currentMaterialLibrary do
						(
						if (superClassOf m as string) != "textureMap" then
							(
							append mats m
							)
						)
					count = mats.count
					rows = count / htmlcolumns
					
					for m in mats do
					(
					$.material = copy currentMaterialLibrary[m.name]
					print m.name


					makeDir (outDir + "\\images")
					b=bitmap ImgWdh ImgHgt fileName: (outDir + "\\" + "\\images\\" + m.name + ".jpg")
					render camera:$Camera01 outputwidth:ImgWdh outputheight:ImgHgt force2sided:true to:b
					save b
					close b

					makeDir (outDir + "\\thumbn")
					thumbn=bitmap thumbWdh thumbHgt fileName: (outDir + "\\thumbn\\" + "\\thumbn_" + m.name + ".jpg")
					render camera:$Camera01 outputwidth:thumbWdh outputheight:thumbHgt force2sided:true to:thumbn
					save thumbn
					close thumbn
					)
					
					for i = 1 to count do
					(
					Format "%"	"<td align=\"center\" bordercolor=\"#000000\" bgcolor=\"#666666\">\n" to:HtmlOut
					m = mats[i]
					
					-- <a href=\"#\" onfocus=\"this.blur();\" onclick=\"javascript:window.open('show_pic.php?bild=".$_pic_orig ."','popup','width=".$_data[0].",height=".$_data[1]."');\">
					
					Format "%" "<a href =\"#\"" to:HtmlOut
					Format "%" " onclick=\"javascript:window.open(" to:HtmlOut
					Format "%" "'images/" to:HtmlOut
					Format "%" (m.name as string) to:HtmlOut
					Format "%" 	".jpg'" to:HtmlOut
					Format "%" ",'popup','width=" to:HtmlOut
					Format "%" (ImgWdh + 25) to:HtmlOut
					Format "%" ",height=" to:HtmlOut
					Format "%" (ImgHgt + 25) to:HtmlOut
					Format "%" "')\" align=\"center\">" to:HtmlOut
					-- The Thumbnail
					Format "%"	"<img src=\"thumbn\\thumbn_" to:HtmlOut
					Format "%"	(m.name as string) to:HtmlOut
					Format "%" ".jpg\" border=\"0\">" to:HtmlOut
					Format "%"	"</a>" to:HtmlOut
					Format "%"	"<br>" to:HtmlOut
					Format "%"	"<font face=\"Arial, Helvetica, sans-serif\" size=\"1\" color=\"#000000\" align=\"center\">\n" to:HtmlOut
					Format "%"	m.name to:HtmlOut
					Format "%"	"</font>\n" to:HtmlOut
					Format "%"	"<br>" to:HtmlOut
					Format "%"	"</td>\n" to:HtmlOut

					for n = 1 to 200 do
					(
					if i == (n * htmlcolumns) do
					(
					Format "%"	"</tr>\n" to:HtmlOut
					Format "%"	"<tr>\n" to:HtmlOut
							)
						)
					)
									
copyFile (getDir#scripts + "\\logo.jpg") (outDir + "\\thumbn\\logo.jpg")		

Format "%"	"</tr>\n" to:HtmlOut
Format "%"	"</table>\n" to:HtmlOut
Format "%" "<br>" to:HtmlOut
Format "%"	"<br>" to:HtmlOut
Format "%"	"<p align=\"center\"><font face=\"Arial, Helvetica, sans-serif\" size=\"1\">done\n" to:HtmlOut
Format "%"  "with MatlibRender 0.5 beta<br>\n" to:HtmlOut
Format "%"  "by Sven -fIRE3d- Dahl - fire3d@brazelized.de<br>" to:HtmlOut
Format "%"	"<p align=\"center\"><font face=\"Arial, Helvetica, sans-serif\" size=\"1\"><img src=\"thumbn\logo.jpg\"></font></p>\n" to:HtmlOut
Format "%"	" <font></p>" to:HtmlOut
Format "%"  "</body>\n"  to:HtmlOut
close HtmlOut

	)

)
rollout1 = newRolloutFloater "Matlib Render 0.5beta" (300) 460
(

addRollout RenderMatlib rollout1			



)